import SocketServer
import threading
import resources
import os

from PyQt4.QtCore import * 
from PyQt4.QtGui import *
from qgis.core import *

class MyTCPHandler(SocketServer.BaseRequestHandler):
    def handle(self):
        self.request.sendall(b'Response')

class ProblemPlugin: 
    def __init__(self, iface):
        self.iface = iface

    def initGui(self):
        self.connect_action = QAction(QIcon(":/plugins/ProblemPlugin/button.png"), 
                              "Connect", self.iface.mainWindow())
        QObject.connect(self.connect_action, SIGNAL("activated()"), self.connect) 
        self.iface.addToolBarIcon(self.connect_action)

        SocketServer.TCPServer.allow_reuse_address = True
        self.server = SocketServer.TCPServer(('localhost', 50007), MyTCPHandler)
        t = threading.Thread(target=self.server.serve_forever)
        t.start()

    def connect(self): 
        input = open(os.path.expanduser('~/.qgis/python/plugins/ProblemPlugin/button.png'), 'rb')
        input.close()

    def unload(self):
        self.iface.removeToolBarIcon(self.connect_action)
